/**********************************************************************************
 *   ********** Computer and Real-Time Group . University of Cantabria **********
 *                         *** SwiftEagle  Project ***   
 *   
 *   Objeto remoto: TargetObserver
 *   Describe un objeto remoto que implementa la interface remota Observer y que
 *   cuando se le invoca desde el servidor signals(), establece a true la variable
 *   esttica asCloseToTarget. Se utiliza como callback del cliente
 *   MissileController en el servidor SwiftEagle.
 *      
 *    Author: J.M. Drake
 *    Version: 08-05-2013
 *
 **********************************************************************************/


import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
// Extiende a UnicastRemoteObject y por ello cuando se crea es ya un objeto activo
// registrado en el RMI. Implementa la interfaz Observer que le exige implementar
// el metodo signal()
public class TargetObserver extends UnicastRemoteObject implements Observer {

	private static final long serialVersionUID = 1L;
	// Constructor
    public TargetObserver() throws RemoteException {
    	super();
    }
	// Metodo requerido por la implementacin de la interfaz Observer
	public void signal() throws RemoteException {
		MissileController.asCloseToTarget=true;
	}
}
