/**********************************************************************************
 *   ********** Computer and Real-Time Group . University of Cantabria **********
 *                         *** SwiftEagle  Project ***   
 *   
 *   Data type: Direction
 *   Proporciona los datos que establecen la direccin de desplazamiento del misil.
 *   contiene los tres cosenos directores que definem la direccin.
 *   
 *    Author: J.M. Drake
 *    Version: 18-05-2014
 *
 **********************************************************************************/

import java.io.Serializable;

public class Direction implements Serializable{
	private static final long serialVersionUID = 333;
	public double ux=0; // Coseno director direccion x
	public double uy=0; // Coseno director direccion y
	public double uz=0; // Coseno director direccion z
	//El control normaliza el vector de entrada para que sean consenos directores
	public Direction(double ux,double uy,double uz){
		double mod=Math.sqrt(Math.pow(ux,2)+Math.pow(uy,2)+Math.pow(uz,2));
		if (mod!=0){this.ux=ux/mod;this.uy=uy/mod;this.uz=uz/mod;}
	}
}
