/**********************************************************************************
 *   ********** Computer and Real-Time Group . University of Cantabria **********
 *                         *** SwiftEagle  Project ***   
 *   
 *   Data type: Missile
 *   Define la interfaz remota que ofrece un misil.
 *   
 *    Author: J.M. Drake
 *    Version: 18-05-2014
 *
 **********************************************************************************/
import java.rmi.*;
public interface Missile extends Remote {
	// Lanza el misil y con ello inicia su movimiento autnomo
	void shot(Position initPos,long password)throws UnreadyException, RemoteException;
	// Retorna la posicion que tiene el missil obtenida de su GPS interno 
	Position getPosition()throws RemoteException;
	// Establece la direccin de avance del misil, en base a proporcionarle sus
	// cosenos directores
	void setDirection(Direction dir)throws RemoteException;
	// Establece la posicin de destino, y el objeto observer al que hay que notificar
	// cuando se alcance
	void nearnessReport(Position pos, Observer observer)throws RemoteException;
	// Se ordena al misil que explote. (Se ejecuta slo si el password coincide con el
	// que internamente tiene definido el missil. 
	void explode(long password)throws UnknownException,RemoteException;
	// Se desactiva el missil, que se destruye sin explotar 
	void turnOff()throws RemoteException;
}
